program randalloy 
implicit none
integer i,j,k,sub,c1,c2,atoms,c11,c22,coo,ke,kee(10000),kk,ele
integer nnn,c(0:12),dec,rand1,rand2
integer, allocatable :: subn(:)
real*8 comp,ra(3),atcomp,prev1,prev2
real*8 x,y,z,zz
real*8, allocatable :: x1(:),y1(:),z1(:)
real*8, allocatable :: x2(:),y2(:),z2(:),raa(:),raa1(:),raa2(:)
character*1 q(6)
character*1 q2(6)
character*2, allocatable :: eln(:)
open(unit=200,file='RANDOM_SUBLATTICE',status='unknown')
call system('head -7 POSCAR | tail -1 | wc | awk ''{print $2}''> ELEMENTS')
open(unit=212,file='ELEMENTS',status='unknown')
read(212,*)ele
prev1=100d0
prev2=-100d0
kee=0
ke=0
c1=0
c2=0
open(unit=10,file='POSCAR',status='old')
open(unit=100,file='RAND',status='old')
call random_seed()
call random_number(zz)
do k=1,int(zz*200000d0)
read(100,*)
enddo
if(ele==1)then
allocate (eln(ele+1))
sub=1
write(*,*)'Give name of the two elements'
read(*,*)eln(sub),eln(sub+1)
elseif(ele==2)then
write(*,'(a)')'Which sublattice to be randomized? give an integer up to a max of 2'
allocate (eln(ele+1))
read(*,*)sub
write(*,*)'Give name of the three elements'
read(*,*)(eln(j),j=1,3)
else
write(*,*)'STOP!! It works with maximum two elements in the original POSCAR!'
stop 
endif
allocate (subn(ele))
write(*,*)'composition? give a fraction between 0 and 1!'
write(*,*)'It determines the number of atoms for the 1st species on the random sublattice'
read(*,*)comp
do i=1,6
read(10,*)
enddo
read(10,*)(subn(j),j=1,ele)
atcomp=anint(real(subn(sub))*comp)
atoms=int(atcomp)
rand1=atoms
rand2=subn(sub)-atoms
read(10,*)
allocate (x1(subn(sub)),y1(subn(sub)),z1(subn(sub)),x2(subn(sub)),y2(subn(sub)),z2(subn(sub)))
allocate (raa(subn(sub)),raa1(subn(sub)),raa2(subn(sub)))
x1=0d0;y1=0d0;z1=0d0;x2=0d0;y2=0d0;z2=0d0
raa1=prev1
raa2=prev2
do j=1,sub
do i=1,subn(j)
if(j==sub)then
read(10,*)x,y,z
call random_seed()
call random_number(zz)
kk=int(zz*3d0)+1
read(100,*)(ra(k),k=1,kk)
ra(1)=ra(kk)
raa(i)=ra(1)
if(ra(1)<=comp)then
c1=c1+1
raa1(c1)=ra(1)
x1(c1)=x
y1(c1)=y
z1(c1)=z
else
c2=c2+1
raa2(c2)=ra(1)
x2(c2)=x
y2(c2)=y
z2(c2)=z
endif
else
read(10,*)
endif
enddo
enddo

if(c1==atoms)then
write(*,*)'CASE C1=ATOMS'
        do i=1,c1
        write(200,'(3f16.12,a,2i5)')x1(i),y1(i),z1(i),' #',i,1
        enddo
        do i=1,c2
        write(200,'(3f16.12,a,2i5)')x2(i),y2(i),z2(i),' #',i,2
        enddo

elseif(c1>atoms)then
write(*,*)'CASE C1>ATOMS'
c22=c2
        do j=1,c1-atoms
        prev1=maxval(raa1,mask=raa1<prev1)
write(*,*)prev1
        do k=1,c1
        if(prev1==raa1(k))then
        c22=c22+1
        ke=ke+1
        kee(ke)=k
        x2(c22)=x1(k)
        y2(c22)=y1(k)
        z2(c22)=z1(k)
        endif
        enddo
        enddo
        coo=0
        do i=1,c1
        do j=1,ke
        if(i==kee(j))goto 777
        enddo
        coo=coo+1
        write(200,'(3f16.12,a,2i5)')x1(i),y1(i),z1(i),' #',coo,1
        777 continue
        enddo
        do i=1,c22
        write(200,'(3f16.12,a,2i5)')x2(i),y2(i),z2(i),' #',i,2
        enddo


else
write(*,*)'CASE C1<ATOMS'
c11=c1
        do j=1,atoms-c1
        prev2=minval(raa2,mask=raa2>prev2)
write(*,*)prev2
        do k=1,c2
        if(prev2==raa2(k))then
        c11=c11+1
        ke=ke+1
        kee(ke)=k
        x1(c11)=x2(k)
        y1(c11)=y2(k)
        z1(c11)=z2(k)
        endif
        enddo
        enddo
        do i=1,c11
        write(200,'(3f16.12,a,2i5)')x1(i),y1(i),z1(i),' #',i,1
        enddo
        coo=0
        do i=1,c2
        do j=1,ke
        if(i==kee(j))goto 778
        enddo
        coo=coo+1
        write(200,'(3f16.12,a,2i5)')x2(i),y2(i),z2(i),' #',coo,2
        778 continue
        enddo
endif

!APPEND UNMODIFIED SUBLATTICE

if(ele==1)then
open(unit=773,file='HEADER',status='unknown')
write(773,'(2a3)')eln(1),eln(2)
call system('head -5 POSCAR | tail -4 > HEADER2')
open(unit=774,file='HEADER3',status='unknown')
write(774,'(2a3)')eln(1),eln(2)
write(774,*)rand1,rand2
write(774,'(a)')'Direct'
call system('cat HEADER HEADER2 HEADER3 RANDOM_SUBLATTICE > POS_Alloy')
call system('rm HEADER HEADER2 HEADER3 RANDOM_SUBLATTICE ELEMENTS')
else

if(ele==1)nnn=subn(1)+8
if(ele==2)then
if(sub==2)then
nnn=subn(1)+8
else
nnn=subn(1)+subn(2)+8
endif
endif
call digits(nnn,dec,c)
do i=1,dec
q(i)=char(48+c(i))
enddo
if(dec==6)call system('head -'//q(1)//q(2)//q(3)//q(4)//q(5)//q(6)//' POSCAR > Ptemp')
if(dec==5)call system('head -'//q(1)//q(2)//q(3)//q(4)//q(5)//'  POSCAR > Ptemp')
if(dec==4)call system('head -'//q(1)//q(2)//q(3)//q(4)//'  POSCAR > Ptemp')
if(dec==3)call system('head -'//q(1)//q(2)//q(3)//'  POSCAR > Ptemp')
if(dec==2)call system('head -'//q(1)//q(2)//'  POSCAR > Ptemp')
if(dec==1)call system('head -'//q(1)//'  POSCAR > Ptemp')

if(ele==1)nnn=subn(1)
if(ele==2)then
if(sub==2)then
nnn=subn(1)
else
nnn=subn(2)
endif
endif
c=0
call digits(nnn,dec,c)
do i=1,dec
q2(i)=char(48+c(i))
enddo
if(dec==6)call system('tail -'//q2(1)//q2(2)//q2(3)//q2(4)//q2(5)//q2(6)//' Ptemp > Pfix')
if(dec==5)call system('tail -'//q2(1)//q2(2)//q2(3)//q2(4)//q2(5)//'  Ptemp > Pfix')
if(dec==4)call system('tail -'//q2(1)//q2(2)//q2(3)//q2(4)//'   Ptemp > Pfix')
if(dec==3)call system('tail -'//q2(1)//q2(2)//q2(3)//'  Ptemp > Pfix')
if(dec==2)call system('tail -'//q2(1)//q2(2)//' Ptemp > Pfix')
if(dec==1)call system('tail -'//q2(1)//'  Ptemp > Pfix')
open(unit=773,file='HEADER',status='unknown')
write(773,'(3a3)')(eln(j),j=1,3)
call system('head -5 POSCAR | tail -4 > HEADER2')
open(unit=774,file='HEADER3',status='unknown')
write(774,'(3a3)')(eln(j),j=1,3)
if(sub==1)then
write(774,*)rand1,rand2,subn(2)
write(774,'(a)')'Direct'
call system('cat HEADER HEADER2 HEADER3 RANDOM_SUBLATTICE Pfix > POS_Alloy')
call system('rm HEADER HEADER2 HEADER3 RANDOM_SUBLATTICE ELEMENTS Pfix Ptemp')
else
write(774,*)subn(1),rand1,rand2
write(774,'(a)')'Direct'
call system('cat HEADER HEADER2 HEADER3 Pfix RANDOM_SUBLATTICE > POS_Alloy')
call system('rm HEADER HEADER2 HEADER3 RANDOM_SUBLATTICE ELEMENTS Pfix Ptemp')
endif
endif

end
