program B1_lattice
implicit none
integer i,j,k,at
integer dx,dy,dz
real*8 fx,fy,fz,ii,jj,kk,lat
real*8, allocatable :: x(:),y(:),z(:)

open(unit=10,file='POSCAR',status='unknown')
write(*,*)'Provide lattice parameter in Angstrom'
read(*,*)lat
write(*,*)'Provide number of unit cell repetitions in x, y, z (type 3 integers)'
read(*,*)dx,dy,dz
write(10,*)'E1 E2'
write(10,*)lat
write(10,*)real(dx),0d0,0.d0
write(10,*)0.d0,real(dy),0d0
write(10,*)0d0,0.d0,real(dz)
write(10,*)'E1 E2'
at=dx*dy*dz*4
write(10,*)at,at
write(10,'(a)')'Direct'
allocate(x(at*2),y(at*2),z(at*2))

fx=1d0/real(dx)
fy=1d0/real(dy)
fz=1d0/real(dz)

do i=0,dx-1
do j=0,dy-1
do k=0,dz-1
ii=real(i)
jj=real(j)
kk=real(k)
write(10,*)fx*(ii+0.0d0),fy*(jj+0.0d0),fz*(kk+0.0d0)
write(10,*)fx*(ii+0.5d0),fy*(jj+0.5d0),fz*(kk+0.0d0)
write(10,*)fx*(ii+0.0d0),fy*(jj+0.5d0),fz*(kk+0.5d0)
write(10,*)fx*(ii+0.5d0),fy*(jj+0.0d0),fz*(kk+0.5d0)
enddo
enddo
enddo

do i=0,dx-1
do j=0,dy-1
do k=0,dz-1
ii=real(i)
jj=real(j)
kk=real(k)
write(10,*)fx*(ii+0.5d0),fy*(jj+0.5d0),fz*(kk+0.5d0)
write(10,*)fx*(ii+0.5d0),fy*(jj+0.0d0),fz*(kk+0.0d0)
write(10,*)fx*(ii+0.0d0),fy*(jj+0.5d0),fz*(kk+0.0d0)
write(10,*)fx*(ii+0.0d0),fy*(jj+0.0d0),fz*(kk+0.5d0)
enddo
enddo
enddo

end
